package org.sonatype.tycho.p2.eclipse.bridge.impl;

import java.io.File;

import org.codehaus.plexus.archiver.UnArchiver;
import org.codehaus.plexus.component.annotations.Component;
import org.codehaus.plexus.component.annotations.Requirement;
import org.codehaus.plexus.logging.Logger;
import org.sonatype.tycho.p2.eclipse.bridge.EclipseLocation;
import org.sonatype.tycho.p2.eclipse.bridge.EclipseLocationFactory;

@Component( role = EclipseLocationFactory.class )
public class DefaultEclipseLocationFactory
    implements EclipseLocationFactory
{

    @Requirement
    private Logger logger;

    @Requirement( hint = "zip" )
    private UnArchiver unArchiver;

    public EclipseLocation createPackedEclipseLocation( final File eclipseArchive )
    {
        return new PackedEclipseLocation( eclipseArchive, unArchiver, logger );
    }

    public EclipseLocation createPackedEclipseLocation( final File eclipseArchive, final File location,
                                                        final boolean reuseExisting )
    {
        return new PackedEclipseLocation( eclipseArchive, location, reuseExisting, unArchiver, logger );
    }

    public EclipseLocation createStaticEclipseLocation( final File location )
    {
        return new StaticEclipseLocation( location );
    }

}
